from __future__ import absolute_import, unicode_literals

import os
import sys

"""
Django settings for masmovil_proxy project.

Generated by 'django-admin startproject' using Django 3.0.4.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

# Celery settings
# http://docs.celeryproject.org/en/latest/userguide/configuration.html

CELERY_BROKER_URL = "amqp://{}:{}@{}:{}/{}".format(
    os.getenv("CELERY_USER"),
    os.getenv("CELERY_PASSWORD"),
    os.getenv("CELERY_IP_ADDRESS"),
    os.getenv("CELERY_PORT"),
    os.getenv("CELERY_VHOST"),
)
CELERY_RESULT_BACKEND = "django-db"
CELERY_ACKS_LATE = True


# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv("DJANGO_SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True if os.getenv("DJANGO_DEBUG_BOOLEAN") == "True" else False

ALLOWED_HOSTS = [os.getenv("ALLOWED_HOSTS")]

# Application definition

INSTALLED_APPS = [
    "api.apps.ApiConfig",
    "django.contrib.staticfiles",
    "django.contrib.contenttypes",
    "django.contrib.messages",
    "django.contrib.admin",
    "django.contrib.auth",
    "rest_framework",
    "django_celery_results",
    "csvimport.app.CSVImportConf",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "bugsnag.django.middleware.BugsnagMiddleware",
]

ROOT_URLCONF = "masmovil_proxy.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "masmovil_proxy.wsgi.application"


# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": os.getenv("MM_PROXY_DB_NAME"),
        "USER": os.getenv("MM_PROXY_DB_USER"),
        "PASSWORD": os.getenv("MM_PROXY_DB_PASSWORD"),
        "HOST": os.getenv("MM_PROXY_DB_HOST"),
        "PORT": "",
    },
    "odoo": {
        "ENGINE": "django.db.backends.postgresql_psycopg2",
        "NAME": os.getenv("ODOO_DB_NAME"),
        "USER": os.getenv("ODOO_DB_USER"),
        "PASSWORD": os.getenv("ODOO_DB_PASSWORD"),
        "HOST": os.getenv("ODOO_DB_HOST"),
        "PORT": os.getenv("ODOO_DB_PORT"),
    }
}

# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "Europe/Madrid"

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = "/static/"

TEST = "test" in sys.argv

if not TEST:
    LOGGING = {
        "version": 1,
        "disable_existing_loggers": False,
        "formatters": {
            "verbose": {
                "format": "[%(asctime)s] %(levelname)s [%(name)s:%(lineno)s] %(message)s",
                "datefmt": "%d/%b/%Y %H:%M:%S",
            }
        },
        "handlers": {
            "console": {"class": "logging.StreamHandler", "formatter": "verbose"},
            "file": {
                "level": os.getenv("DJANGO_LOGGING_LEVEL"),
                "class": "logging.handlers.RotatingFileHandler",
                "maxBytes": 1024 * 1024 * 50,  # 50 MB
                "backupCount": 10,
                "filename": "{}/app.log".format(os.getenv("DJANGO_LOGGING_PATH")),
                "formatter": "verbose",
            },
        },
        "loggers": {
            "api": {
                "handlers": ["console", "file"],
                "level": os.getenv("DJANGO_LOGGING_LEVEL"),
            },
            "bugsnag": {
                "level": "ERROR",
                "class": "bugsnag.handlers.BugsnagHandler",
            },
        },
    }

# Disable REST_FRAMEWORK default authentication methods
REST_FRAMEWORK = {"DEFAULT_AUTHENTICATION_CLASSES": ()}
